%{ 
Written by Richard Day of EGO
version dated August 2013
this is the latest - so far - which has the Gabriele's contribution
34 digits is not quite necessary, but there is almost no speed gain by reducing to 28

comments by Hiro  Feb. 1, 2017

n = 1:AccN   : number of iteration
if AveN==0
    AveN=ones(1,AccN);
else
    AveN=AveN*ones(1,AccN);
    AveN(2:2:end)=AveN(2:2:end)+1;
end

*** example for 1 cavity
P = NC';
E = EN';
Et = cell(1,1);
Et{1} = NEt;
[EG ratio] = R_getguessFin(P,E,Et);    
eNguess = EG{1};

*** example for 2 cavities
P = [RC' ; RN' ; ...
     NR' ; NC'   ];
E = [ER' ; EN'];
Et = cell(2,1);
Et{1} = REt ;
[EG ratio] = R_getguessFin(P,E,Et);    
eRguess = EG{1}; 
eNguess = EG{2};

%}

% Pmat = repmat( struct( 'Em', zeros(AccN, Nfft, Nfft) ), Nguess, Nguess )
% Pmat( g2, g1 ) : field from guessID1 to guessID2
function [EG, ratio]  = R_getguessFinMat(Pmat,E,Et)

% mysize = size(P);
% CavN = sqrt(mysize(1));
% AccN = mysize(2);

CavN = size(Pmat,1);
AccN = size(Pmat(1,1),1);

for iC = 1 : CavN*CavN
    for iA = 2 : AccN
        Pmat(iC).Em(iA,:) = Pmat(iC).Em(iA,:) - Pmat(iC).Em(1,:);
    end
end

% 
% for j=1:CavN*CavN
%     for k=2:AccN
%         Pmat{j,k}=Pmat{j,k}-Pmat{j,1};
%     end
% end

sgn=2*eye(CavN,CavN)-ones(CavN,CavN);

B1 = (zeros(CavN*AccN,CavN*AccN));
B2 = (zeros(CavN*AccN,CavN*AccN));
B3 = (zeros(CavN*AccN,CavN*AccN));
B4 = (zeros(CavN*AccN,CavN*AccN));

for gID2=1:CavN
    for gID1=1:CavN
        B1(((gID2-1)*AccN+1):((gID2-1)*AccN+AccN),((gID1-1)*AccN+1):((gID1-1)*AccN+AccN)) = sgn(gID2,gID1) * sum(sum(conj(Pmat(gID2,gID2).Em(1,:)) .* Pmat(gID2,gID1).Em(1,:)));
        for iA=2:AccN
            B2(((gID2-1)*AccN+iA),((gID1-1)*AccN+1):((gID1-1)*AccN+AccN)) = sgn(gID2,gID1) * sum(sum(conj(Pmat(gID2,gID2).Em(iA,:)) .* Pmat(gID2,gID1).Em(1,:)));
        end
        for iA=2:AccN
            B3(((gID2-1)*AccN+1):((gID2-1)*AccN+AccN),((gID1-1)*AccN+iA)) = sgn(gID2,gID1) * sum(sum(conj(Pmat(gID2,gID2).Em(1,:)) .* Pmat(gID2,gID1).Em(iA,:)));
        end
        for iA=2:AccN
            for iA2=2:AccN
                B4(((gID2-1)*AccN+iA),((gID1-1)*AccN+iA2)) = sgn(gID2,gID1) * sum(sum(conj(Pmat(gID2,gID1).Em(iA,:)) .* Pmat(gID2,gID2).Em(iA2,:)));
            end
        end
    end
end

R1 = zeros(AccN*CavN,1);
R2 = zeros(AccN*CavN,1);
for gID=1:CavN
    if ~isempty(Et{gID})
        R1((gID-1)*AccN+1:(gID-1)*AccN+AccN) = sum(sum(conj(Pmat(gID,gID).Em(1,:)) .* Et{gID}));
        for l=2:AccN
            R2(l+(gID-1)*AccN) = sum(sum(conj(Pmat(gID,gID).Em(l,:)) .* Et{gID}));
        end
    end
end

% flag=1 matlab vpa(34)
% flag=2 advanpix mp(34)
% flag=3 standard double
ratio = 1/cond(B1+B2+B3+B4);
if (ratio<1e-15)
    flag = 1;
else
    flag = 3;
end

coefs  = R_thecalc(B1,B2+B3,B4,R1,R2,flag);

EG=cell(CavN,1);
EG(:)={zeros(size(E{1}))};
for iA=1:CavN
    for gID2=1:AccN
        EG{iA} = EG{iA} + coefs(gID2+(iA-1)*AccN)*E{iA,gID2};
    end
end
return

function coefs  = R_thecalc(B1,B23,B4,R1,R2,flag)

switch flag
    case 1
        dig = digits(34); % save current digits
        coefs=(vpa(B1)+vpa(B23)+vpa(B4))\(vpa(R1)+vpa(R2));
        digits(dig);  % restore the previous
    case 2
        mp.Digits(34);
        mp.GuardDigits(0);
        coefs=(mp(B1)+mp(B23)+mp(B4))\(mp(R1)+mp(R2));
    case 3
        coefs=(B1+B23+B4)\(R1+R2);
end

coefs=double(coefs);
return
