% function val = zernikeFunc( radial, azim, r, theta, normalize )

function val = zernikeFunc( radial, azim, r, theta, normalize )

m = abs(azim);

val = radialFunc( radial, m, r );
if azim > 0
    val = val .* cos( m * theta );
elseif azim < 0
    val = val .* sin( m * theta );
end

if (nargin == 5) && (normalize ~= 0)
    val = val * sqrt( (radial+1)/pi );
    if azim ~= 0
        val = val * sqrt(2);
    end
end
return


function valR = radialFunc( n, m, r )

switch n
    case 0
        switch m
        	case 0
                valR = ones(size(r));
            otherwise
                valR = zeros(size(r));
        end

    case 1
        switch m
			case 1
                valR = r;
            otherwise
				valR = zeros(size(r));
        end

    case 2
        switch m
            case 0
                valR = 2*r.^2 - 1;
            case 2
                valR = r.^2;
            otherwise
                valR = zeros(size(r));
        end
    case 3
        switch m
			case 1
                valR = 3*r.^3 - 2*r;
			case 3
                valR = r.^3;
            otherwise
                valR = zeros(size(r));
        end

    case 4
        switch m
			case 0
                valR = 6*( r.^4 - r.^2 ) + 1;
			case 2
                valR = 4*r.^4 - 3*r.^2;
			case 4
                valR = r.^4;
            otherwise
                valR = zeros(size(r));
        end

    otherwise
        if mod( n - m, 2 ) ~= 0
            valR = 0;
        elseif n == m
            valR = r.^n;
        elseif n == (m+2)
            valR = n*r.^n - (n-1)*r.^(n-2);
        else
            nn = m + 4;
            val2 = radialFunc( nn - 2, m, r );
            val4 = radialFunc( nn - 4, m, r );
            while nn <= n
                valR = nn/(nn^2-m^2) ...
                    *( (4*(nn-1)*r.^2 ...
                        -(nn+m-2)^2/(nn-2)-(nn-m)^2/nn) ...
                        .* val2 ...
                        - ((nn-2)^2-m^2)/(nn-2)*val4 );
                val4 = val2;
                val2 = valR;
                nn = nn + 2;
            end
            valR = val2;
        end
end

return
